/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stateless;

import javax.ejb.Stateless;
import javax.ejb.LocalBean;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import java.util.*;
import book.entities.*;
import javax.ejb.Local;
import javax.ejb.Remote;
import javax.persistence.TypedQuery;
/**
 *
 * @author armel
 */
@Stateless(name="BookSB", mappedName="stateless/Book")
public class BookBean implements BookRemote{
  //  private Book book;
    private List<Book> books;
    private List<Author> authors;

    // ======================================
    // =             Attributes             =
    // ======================================

    @PersistenceContext(unitName = "app_book-ejbPU")
    private EntityManager em;

    // ======================================
    // =           Public Methods           =
    // ======================================

    @Override
    public List<Book> findBooks() {
        // TODO not implemented with eclipselink 2.0 TypedQuery query = em.createNamedQuery("findAllBooks", Book.class);
       Query query=em.createQuery("SELECT b FROM Book b");
       // Query query=em.createQuery("SELECT book FROM Book book JOIN book.author aut");
        // Query query=em.createQuery("SELECT aut FROM Author aut JOIN aut.book b");
       // Query query = em.createNamedQuery("findAllBooks");chap 10
        books= query.getResultList();
      //  return books;
        return query.getResultList();
    }
    
    
    @Override
     public List<Author> findAuthors() {
       Query query=em.createQuery("SELECT a FROM Author a JOIN a.books b");
        // Query query=em.createQuery("SELECT aut FROM Author aut JOIN aut.book b");
        this.authors= query.getResultList();
        
        return authors;
    }
    
    
    
    
//SELECT pub FROM Publisher pub LEFT JOIN pub.magazines mag WHERE pub.revenue > 1000000
    @Override
    public Author findAuthor(Long authorId) {
        
        if(authorId ==null )
            new Exception("Id author est null");
        Author author;
        author=em.find(Author.class, authorId);
        return author;
    }
    
     @Override
    public Book createBook(Book book, Author author) {
         //this.book=new Book();
         
       // book.setAuthor(author);
     //    author.setBook(book);
        em.persist(author);
        return book;
    }
     
     
     @Override
    public Author createAuthor(Book book, Author author) {
         //this.book=new Book();
         List<Book> books=new ArrayList<Book>();
         books.add(book);
         author.setBook(books);
        em.persist(author);
        return author;
    }

    @Override
    public List<Author> authenticate(String login, String password) {
         Query query=em.createQuery("SELECT a FROM Author a WHERE a.login =:login AND a.password=:password");
         query.setParameter("login", login);
         query.setParameter("password", password);
          
        List<Author> author=query.getResultList();
       // throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
        return author;
    }

}
