/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package controllers;

import book.entities.Author;
import book.entities.Book;
import javax.inject.Named;
import javax.enterprise.context.SessionScoped;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import javax.ejb.EJB;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.servlet.http.HttpSession;
import stateless.BookRemote;

/**
 *
 * @author armel
 */
@Named(value = "authentificationBean")
@SessionScoped
public class AuthentificationBean implements Serializable {

    
     @EJB
    private BookRemote bookEJB;
    
   private Author author=new Author();

    public void setAuthor(Author author) {
        this.author = author;
    }

    public Author getAuthor() {
        return author;
    }

    private Book book = new Book();
   // private List<Book> bookList = new ArrayList<Book>();
    //private List<Author> authorList = new ArrayList<Author>();
    
    /**
     * Creates a new instance of AuthentificationBean
     */
    public AuthentificationBean() {
    }
    private String identifiant;
    private String motdepasse;

    public String getIdentifiant() {
        return identifiant;
    }

    public void setIdentifiant(String identifiant) {
        this.identifiant = identifiant;
    }

    public String getMotdepasse() {
        return motdepasse;
    }

    public void setMotdepasse(String motdepasse) {
        this.motdepasse = motdepasse;
    }
// valider l’authentification
    public String validerAuthentification() {
        FacesMessage message = null;
        String redirection = "login";
        
        if( !this.bookEJB.authenticate(author.getLogin(),author.getPassword()).isEmpty()){
            message = new FacesMessage("Autentification réalisée avec succès");
            redirection = "success";
            
        }else {
            message = new FacesMessage("Erreur lors de l’authentification");
        }
        /*
        
// authentification OK
        if (this.identifiant.equals("armel")
                && this.motdepasse.equals("pass")) {
            message = new FacesMessage("Autentification réalisée avec succès");
            redirection = "success";
        } // authentification KO
        else {
            message = new FacesMessage("Erreur lors de l’authentification");
        }
        */
//ajouter le message JSF
        FacesContext.getCurrentInstance().addMessage(null, message);
        return redirection;
    }
    
    public String doLoggout(){
        FacesContext fc=FacesContext.getCurrentInstance();
        HttpSession session =( HttpSession)
                             fc.getExternalContext().getSession(false);
        session.invalidate();
          return "index.xhtml?faces-redirect=true";
        //return "index.xhtml";
    }
}//end class
