/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package controllers;
import book.entities.Author;
import book.entities.Book;
import java.util.*;
import javax.ejb.*;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;
import stateless.BookBean;
import stateless.BookRemote;
/**
 *
 * @author armel
 */
@ManagedBean(name ="bookController")
@RequestScoped
public class BookController {
    
     // ======================================
    // =             Attributes             =
    // ======================================

    @EJB
    private BookRemote bookEJB;
    
   private Author author=new Author();

    private Book book = new Book();
    private List<Book> bookList = new ArrayList<Book>();
    private List<Author> authorList = new ArrayList<Author>();

    // ======================================
    // =           Public Methods           =
    // ======================================

    public String doNewBookForm() {
       
         bookList = bookEJB.findBooks();
        return "newBook.xhtml";  // Works without faces-config.xml
    }
    
    public String doCreateBook() {
        //book = bookEJB.createBook(book);
        book = bookEJB.createBook(book, author);
        bookList = bookEJB.findBooks();
     //  return "listBook.xhtml";
     return "index.xhtml";
    }
    
    
    public String newBook() {
     //  book.setAuthor(author);
       bookList.add(book);
       author.setBook(bookList);
       
       author = bookEJB.createAuthor(book, author);
       
     //  bookList = author.getBook();
       
       return "index.xhtml";
    }
    
    
     public String listAut() {
     // book = bookEJB.createBook(book, author);
        /* for(Book b : bookList){
            authorList.add(author);
         }*/
        authorList = bookEJB.findAuthors();
        return "books.xhtml";
    }
    
    
    public String listBook() {
       
       //book = bookEJB.createBook(book, author);
        bookList = bookEJB.findBooks();
        
        
       // return "listBooks.xhtml";
        return "listBook.xhtml";
    }
    
     public String listAuthors() {
      book = bookEJB.createBook(book, author);
        bookList = bookEJB.findBooks();
        return "newBook.xhtml";
        //return "index.xhtml";
    }

    // ======================================
    // =          Getters & Setters         =
    // ======================================

    public Book getBook() {
        return book;
    }

    public void setBook(Book book) {
        this.book = book;
    }
    
    public Author getAuthor(){
        
        return author;
    }
    
    public void setAuthor(Author author ){
        this.author = author;
    }

    public List<Book> getBookList() {
        return bookList;
    }
    
    public List<Author> getAuthorList() {
        return this.authorList;
    }

    public void setBookList(List<Book> bookList) {
        this.bookList = bookList;
    }
    
     public void setAuthorList(List<Author> _authorList) {
        this.authorList=_authorList;
    }
    /***************************************/
     
     
     public String favCoffee1;
	public String favCoffee2;
	public String favCoffee3;
 
	public String getFavCoffee1() {
		return favCoffee1;
	}
 
	public void setFavCoffee1(String favCoffee1) {
		this.favCoffee1 = favCoffee1;
	}
 
	public String getFavCoffee2() {
		return favCoffee2;
	}
 
	public void setFavCoffee2(String favCoffee2) {
		this.favCoffee2 = favCoffee2;
	}
 
	public String getFavCoffee3() {
		return favCoffee3;
	}
 
	public void setFavCoffee3(String favCoffee3) {
		this.favCoffee3 = favCoffee3;
	}

     
     
     
     	private static Map<String,Object> coffee2Value;
	static{
		coffee2Value = new LinkedHashMap<String,Object>();
		coffee2Value.put("Coffee2 - Cream Latte", "Cream Latte"); //label, value
		coffee2Value.put("Coffee2 - Extreme Mocha", "Extreme Mocha");
		coffee2Value.put("Coffee2 - Buena Vista", "Buena Vista");
	}
 
	public Map<String,Object> getFavCoffee2Value() {
		return coffee2Value;
	}
     
}
